SystemOrganization addCategory: #'GBT-DSL_SEU'!

Object subclass: #GbtSdeCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_SEU'!

!GbtSdeCompiler class methodsFor: 'example' stamp: 'hk 1/10/2018 13:44'!
exampleClearStore
	GbtServer clearStore: #SDE
! !

!GbtSdeCompiler class methodsFor: 'example' stamp: 'hk 1/10/2018 13:44'!
exampleRun
	GbtServer initialize: #SDE.
	(self new 
		ensureCompilation; 
		sdeCompilerAC ) ui 
			title: 'GBT-SDE'; 
			open! !

!GbtSdeCompiler methodsFor: 'functions' stamp: 'hk 1/12/2018 14:38'!
behaviors
	^'
	behavior NewFromApp { 
		appList 		: gbt ( ''GbtServer instanceNames'' )
		selectedApp 	: askUser ( ''Welche App?'' appList)
		newSource 	: newContextThing (EditAC)
		NewFromApp 	: newSource:bizAppName := selectedApp
	}
	behavior getThings { 
		context 		: contextThing(EditAC)
		appName		: context:bizAppName
		getThings 	: gbt ( ''GbtServer appThingsOf:'' appName)
	}
	behavior reverse { 
		things 		: apply(ThingsCompilerAC:getThings)
		thing 			: askUser ( ''Welches Thing?'' things)
		reverse 		: apply(oneReverse thing)
	}
	behavior allReverse { 
		things 		: apply(getThings)
		allSources 	: applyOnList (oneReverse things)
		source 		: contextThing(EditAC)
		allReverse 	: source:things := nodeList(allSources)
	}
	behavior oneReverse { 
		arg1 			: % the input thing
		newSource		: newContextThing(ThingCompilerAC)
		newSource1 	: newSource:sourceName := arg1:svoName
		oneReverse 	: newSource1:source := arg1:gbtSource
	}
	'! !

!GbtSdeCompiler methodsFor: 'contexts' stamp: 'hk 1/11/2018 18:54'!
contexts
	^ '
	plain SdeCompilerAC { 
		subcontexts 	: 	ApplicationsEditAC  ApplicationsTestAC
		uiSpec 		: 	GbtMainUI 
		icon 			: 	GbtIcon96
		windowSize 	: 	1200 @ 900
		legalText 	: 	GloConn International © 2018
		}
	primeList ApplicationsEditAC of AppSource {  
	 	displayAs 	: 	ApplicationsEditor
		uiSpec 		: 	GbtListAndItemUI
		icon 			: 	GbtIcon16
		loadPolicy 	: 	autoload 
		listPrefix 	: 	App 
		subcontext 	:  EditAC
		menu 			:  NewFromApp
		behaviors 	:  NewFromApp
		}
	primeList ApplicationsTestAC of AppTestData {
	 	displayAs 	: 	ApplicationTestData
		uiSpec 		: 	GbtListAndItemUI 
		icon 			: 	GbtIconTest16
		listPrefix 	: 	AppTD 
		subcontext 	:  TestAC
		}
	plain EditAC on AppSource {
	 	displayAs 	: 	ApplicationSource
		subcontexts 	: 	ThingsCompilerAC ProjectorsCompilerAC ContextsCompilerAC BehaviorsCompilerAC
		uiSpec 		: 	GbtItemWithTabsUI 
		icon 			: 	GbtIconEdit16
		}
	plain TestAC on AppTestData {
	 	displayAs 	: 	ApplicationTestData
		subcontexts 	: 	TestThingsAC TestProjectorsAC 
		uiSpec 		: 	GbtItemWithTabsUI 
		icon 			: 	GbtIconTest16
		}

	uList ThingsCompilerAC of GbtSource {  
	 	displayAs 	: 	Things
		uiSpec 		: 	GbtListAndItemUI
		icon 			: 	GbtIconThing16
		listPrefix 	: 	T 
		subcontext 	: 	ThingCompilerAC 
		menu 			:  reverse 
		menu 			:  allReverse
		behaviors 	:  oneReverse reverse allReverse getThings
		elderSlot	: things
		}
	plain ThingCompilerAC {  
	 	displayAs 	: 	SDE
		uiSpec 		: 	GbtItemUI
		icon 			: 	GbtIconThing16
		}
	uList ProjectorsCompilerAC of GbtSource {  
	 	displayAs 	: 	Projectors
		uiSpec 		: 	GbtListAndItemUI
		icon 			: 	GbtIconThing16
		listPrefix 	: 	P
		subcontext 	: 	ProjectorCompilerAC 
		elderSlot	 	: projectors
		}
	plain ProjectorCompilerAC {  
	 	displayAs 	: 	SDE
		uiSpec 		: 	GbtItemUI
		icon 			: 	GbtIconThing16
		}
	uList ContextsCompilerAC of GbtSource {  
	 	displayAs 	: 	Contexts
		uiSpec 		: 	GbtListAndItemUI
		icon 			: 	GbtIconCtxt16
		listPrefix 	: 	C 
		subcontext 	: 	ContextCompilerAC 
		elderSlot	: contexts
		}
	plain ContextCompilerAC {  
	 	displayAs 	: 	SDE
		uiSpec 		: 	GbtItemUI
		icon 			: 	GbtIconCtxt16
		}
	uList BehaviorsCompilerAC of GbtSource {  
	 	displayAs 	: 	Behaviors
		uiSpec 		: 	GbtListAndItemUI
		icon 			: 	GbtIconBeh16
		listPrefix 	: 	B 
		subcontext 	: 	BehaviorCompilerAC 
		elderSlot	: behaviors
		}
	plain BehaviorCompilerAC {  
	 	displayAs 	: 	SDE
		uiSpec 		: 	GbtItemUI
		icon 			: 	GbtIconBeh16
		}
		
	uList TestThingsAC of GbtSource {  
	 	displayAs 	: 	Things
		uiSpec 		: 	GbtListAndItemUI
		icon 			: 	GbtIconThing16
		listPrefix 	: 	T 
		subcontext 	: 	TestThingAC 
		elderSlot	: things
		}
	plain TestThingAC {  
	 	displayAs 	: 	SDE
		uiSpec 		: 	GbtItemUI
		icon 			: 	GbtIconThing16
		}
	uList TestProjectorsAC of GbtSource {  
	 	displayAs 	: 	Projectors
		uiSpec 		: 	GbtListAndItemUI
		icon 			: 	GbtIconThing16
		listPrefix 	: 	P
		subcontext 	: 	TestProjectorAC 
		elderSlot	: projectors
		}
	plain TestProjectorAC {  
	 	displayAs 	: 	SDE
		uiSpec 		: 	GbtItemUI
		icon 			: 	GbtIconThing16
		}

	'! !

!GbtSdeCompiler methodsFor: 'functions' stamp: 'hk 1/2/2018 15:49'!
directives
	^''! !

!GbtSdeCompiler methodsFor: 'compile' stamp: 'hk 1/8/2018 17:58'!
ensureCompilation
	"sort of incremental ..."  
	{self things . self directives . self contexts . self behaviors} do: [:sources | 
		GbtCompiler new parse: sources onError: [ :msg :pos | self error: msg, ' at: ', pos printString ]]! !

!GbtSdeCompiler methodsFor: 'contexts' stamp: 'hk 1/2/2018 15:52'!
sdeCompilerAC 
	^GbtActiveContext definedAs: 'SdeCompilerAC' ! !

!GbtSdeCompiler methodsFor: 'things' stamp: 'hk 1/9/2018 20:38'!
things
^'	thing AppSource 
		summary 						:  #shortDescription
		{ 
		*val bizAppName				:
		*val shortDescription 	:
		*text 	longDescription		:  
		*list things 				:  GbtSource 
		*list projectors 			:  GbtSource 
		*list contexts 				:  GbtSource
		*list behaviors 			:  GbtSource
		}
	thing GbtSource 
		summary 						:  #sourceName
		{ 
		*val sourceName 			:
		*text	source 				:  
		}	
	thing AppTestData 
		{ 
		*val bizApp 					:
		*val shortDescription 	:
		*text 	longDescription		:  
		*list things 				:  GbtSource 
		*list projectors 			:  GbtSource 
		}
'
! !

Object subclass: #GbtSdeTester
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_SEU'!
